﻿var jwt = require('jsonwebtoken');
var moment = require('moment-timezone');
var requestParam = require('request-param')();


function param(req, name) {
    if (typeof (req.param) != 'function')
        requestParam(req, undefined, function () { });
    return req.param(name);
}
/** 
    * Create new access tocken for this req
    *
    * @param {Request} req: The owner request
    * @param {object} value: the value object
    * @param {Number} expireTime: the time in seconds
    */
exports.createToken = function (req, value, expireTime) {
    var options = req.app.get('machiModule').options;
    var token = jwt.sign({ user: req.user, value: value }, options.jwtSecret, { expiresIn: expireTime });
    return { accessToken: token, expiresAt: moment.utc().add(expireTime, 'seconds') };
}

/** 
    * Verify the request
    *
    * @param {Request} req: The owner request
    */
exports.verifyToken = function (req) {
    var options = req.app.get('machiModule').options;
    var accessToken = param(req, "access_token") || param(req, "accessToken") ||param(req, "accesstoken") || req.headers["access_token"] || req.headers["accessToken"] || req.headers["accesstoken"] || req.cookies['access_token'] || req.cookies['accessToken'] || req.cookies['accesstoken'];
    try {
        var data = jwt.verify(accessToken, options.jwtSecret);
        return data;
    } catch (err) {
        return false;
    }
}
