﻿var MachiUtilities  = function (app) {
    this.init(app);
}

MachiUtilities.prototype = {
    /**
     * Initlize the Connector instance
     *
     * @method
     *
     * @param {Express} app - The express app
     */
    init: function (app) {
        var instance = this;
        this.app = app;
        instance.machiModule = app.get('machiModule');
      
    },
    /**
     * Updates the user's profile
     * @method constructProfile
     * @param req The request
     * @param profile the new user's profile info
     */
    updateProfile: function (req, profile, callback) {
        var instance = this,
            machiModule = instance.machiModule,
            options = machiModule.options,
            tokens = machiModule.tokens;
        profile = JSON.parse(JSON.stringify(profile));
        var username = req.user.username;
        var oldEmail = req.user.email;
        var newEmail = profile.email;

        //Make sure the user verifed his new email address
        if (oldEmail != newEmail) {
            profile.email = oldEmail;
            var confirmEmailUrl = options.baseURL + options.routes.confirmEmail + '?token=' + tokens.createToken('ConfirmEmail', { username: username, newEmail: newEmail }, 60 * 60);
            machiModule.emails.sendEmailTo(username, newEmail, 'confirmEmail', {
                confirmEmailUrl: confirmEmailUrl
            }, function () { });
        }
        machiModule.connect.updateUser(username, profile, function (err, newUser) {
            if (!err)
                req.session.passport.user = newUser.profile;
            callback(err, newUser);
        });
    }


}

module.exports.MachiUtilities = MachiUtilities;