﻿//Create a session instance for that normally used for express app

var  extend  =  require('node.extend');

var defaultSessionOptions = {
    secret: new Date().valueOf(),
    resave: false,
    saveUninitialized: false,
    cookie: {
        maxAge: 30 * 24 * 60 * 60 * 1000,
    },
    rolling: true,
    name:'MachinaV1',
    domain: ''
};


module.exports = function (sessionOptions) {
    var session = require('express-session');

    sessionOptions = extend({},defaultSessionOptions, sessionOptions);
    if (sessionOptions.store == 'redis') {
        if (!sessionOptions.redisClient)
            throw 'Please provide the redis client with sessionOptions.redisClient';
        var RedisStore = require('connect-redis')(session);
        sessionOptions.store = new RedisStore({
            client: sessionOptions.redisClient,
            ttl: sessionOptions.cookie.maxAge
        });
    } else {
        var FileStore = require('session-file-store')(session);
        defaultSessionOptions.store = new FileStore({
            path: '/tmp/sessions',
            ttl: defaultSessionOptions.cookie.maxAge
        });
    }
    return session(sessionOptions);
}

/*
module.exports = function (cookieOptions) {
    var cookieSession = require('cookie-session');

    var sessionOptions = {
        secret: cookieOptions.secret ,
        maxAge: cookieOptions.maxAge || 30 * 24 * 60 * 60 * 1000,
        name: cookieOptions.name || 'Machina',
		domain: cookieOptions.domain
    };

    var instance = cookieSession(sessionOptions);

    return function (req, res, next) {
        req.session = req.session || {};
        instance(req, res, function () {
            //Add save function with callback
            if (req.session && req.session.save) {
                req.session.oldSave = req.session.save;
                req.session.save = function (cb) {
                    req.session.oldSave();
                    if (cb) cb();
                }
            }
            next();
        });
    };
}
*/