﻿var passport = require('passport');
var Strategy = require('passport-local').Strategy;
var flash = require('req-flash');



passport.serializeUser(function (user, cb) {
    cb(null, user);
});

passport.deserializeUser(function (user, cb) {
    cb(null, user);
});

module.exports = function (app) {
    var machiModule = app.get('machiModule');
    var options = machiModule.options;

    passport.use(new Strategy(
        {
            usernameField: 'username',
            passwordField: 'password',
            session: false
        },
    function (username, password, cb) {

        machiModule.connect.validateLogin(username, password, cb);

    }));

    app.use(machiModule.cookieMiddleware);
    app.use(flash());

    // Initialize Passport and restore authentication state, if any, from the
    // session.
    app.use(passport.initialize());
    app.use(passport.session());

    //If request uses accessTokens then authorize it
    app.use(machiModule.middleware.accessTokenAuthorize);
     //If request uses basic auth then authorize it
    app.use(machiModule.middleware.basicAuthorize);

    return function (req, res, next) {
        passport.authenticate('local', { failureRedirect: req.originalUrl  })(req, res, function (err) {
            if (!err) return req.session.save(next);
            req.flash('error', err);
            req.flash('body', req.body);
            res.redirect(req.originalUrl);
        });
    };

}






