﻿

/**
 * Return all request's paramters as array
 * 
 * @param {Object} req: The request object
 * */
exports.getExpressRequestParams = function (req, excludeNullValues) {
    var params = {};
    [req.params, req.body.params || req.body, req.query].forEach(function (array) {
        for (var n in array) {
            if (!excludeNullValues || array[n])
                params[n] = array[n];
        }
    });
    return params;
}

/**
 * Send reply to the res object
 * 
 * @param {Object} res: The responce object
 * @param {Object} error: The error object or text
 * @param {Object} result: The result object or text
 * @param {Object} otherProperties: Attach more properties to the result
 * */
exports.reply = function (res, error, result, otherProperties) {
    if (error instanceof Error) {
        error = error.message;
    }
    otherProperties = otherProperties || {};
    otherProperties.error = error;
    if (result)otherProperties.result = result;
    res.send(otherProperties);
}