﻿var speakeasy = require('speakeasy');
var QRCode = require('qrcode');

//this file used to create tokens using two factor auth, 
var TwoFactorAuth = function () { }

TwoFactorAuth.prototype = {
    /** 
    *  Generate a secret key of length 32, which will be the secret key for the user.
    *
    */
    generateSecret: function () {
        return speakeasy.generateSecret().base32;
    },
    /**
    *  Generate a QR code.
    *
    */
    generateQRImage: function (secret,callback) {
        QRCode.toDataURL('otpauth://totp/machi.na?secret=' + secret, callback);
    },
    /** 
    *  Return true if the token is successfully verified, false if not.
    *
    */
    verify: function (base32secret, userToken) {
        var instance = this;
        var verified = speakeasy.totp.verify({
            secret: base32secret,
            encoding: 'base32',
            token: userToken,
            window: 2
        });
        return verified;
    }
}

exports.TwoFactorAuth = TwoFactorAuth;